""" Copyright start
  Copyright (C) 2008 - 2025 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end """

import os
FRAMEWORK_PATH = os.path.dirname(os.path.abspath(__file__))
REPORT_FILE = f"/{FRAMEWORK_PATH}/outputs/report-{{}}.json"
STEP_RESULT_FILE = f"/{FRAMEWORK_PATH}/outputs/step_result-{{}}.json"
CHECK_READINESS_STATUS_FILE = f"/{FRAMEWORK_PATH}/.check_readiness_status"
EXECUTE_PRE_UPGRADE_PHASE_STATUS_FILE = f"/{FRAMEWORK_PATH}/.execute_pre_upgrade_phase_status"
EXECUTE_POST_UPGRADE_PHASE_STATUS_FILE = f"/{FRAMEWORK_PATH}/.execute_post_upgrade_phase_status"
EXECUTE_STATUS_FILE = f"/{FRAMEWORK_PATH}/.execute_status"
CONFIG_FILES_PROPERTIES = [f"{FRAMEWORK_PATH}/config/logger.conf"]
CONFIG_FILES_YAML = ['/opt/cyops/configs/fsr-elevate/config.yml']
LOG_FILE = os.environ.get('LOG_FILE_WITH_TIMESTAMP', '/var/log/cyops/fsr-elevate/fsr-elevate.log')
LOG_FILE_WITH_TIMESTAMP = '/var/log/cyops/fsr-elevate/fsr-elevate-{}-{}.log'
REPO_URL = 'repo.fortisoar.fortinet.com'
REPO_PATH = 'https://{}/{}/elevate/elevate-{}.zip'
CHECKSUM_PATH = 'https://{}/{}/elevate/elevate-{}-checksum.txt'
MODULE_TO_IMPORT = 'workflow.{}.{}'
VERSION_FILE = '/etc/yum/vars/fsr_release_version'
TASK_TEMPLATE_PATH = '{}/templates/task_file_template.json'
SCRIPT_TEMPLATE_PATH = '{}/templates/shell_file_template.json'
PHASE_ARGUMENT = ['pre-upgrade', 'post-upgrade']
LIST_PHASES = ['pre-upgrade', 'upgrade', 'post-upgrade']
PHASE_MAP_DICT = {'pre-upgrade': 'pre_upgrade',
                  'upgrade': 'upgrade', 'post-upgrade': 'post_upgrade'}
UNWANTED_FILES_DIR = ['DS_Store', 'MACOSX']
HTTPS_STATUS_CODES = {200: "The requested file {} was found OK",
                      404: "The requested file {} was not found",
                      500: "Server error requesting the file {}"}
VERSION_PATTERN = r'^\d+(\.\d+){2}$'
VERSION_NON_NUMERIC_NON_DOT_CHECK_PATTERN = r'[^0-9.]'
CHECK_READINESS_PHASES = ['pre-upgrade']
PHASE_DIR_NOT_EXISTS = "{} phase directory does not exists."
PASCAL_CASE_PATTERN = r'^([A-Z][a-zA-Z0-9]*)+$'
TASK_FILE_NAME_PATTERN = r'^\d+_[a-z0-9_]*$'
SNAKE_CASE_PATTERN = r'^[a-z0-9_]+$'
NO_RETRIGGER_COMMANDS = ["check-readiness", "execute-phase", "execute"]
MSG_WIDTH = 80
SPACE_BEFORE_MSG = 2
HTTPS_STATUS_CODE_AND_MESSAGES = {400 : "Https status code : 400 Bad Request", 401 : "Https status code : 401 Unauthorized", 403 : "Https status code : 403 Forbidden", 404 : "Https status code : 404 Not Found", 503 : "Https status code : 503 Bad Gateway"}
UPGRADE_LOG_FILE = "/var/log/cyops/upgrade-fortisoar-{}-{}-{}.log"
TEXT_COLOR={'GREEN':'\033[92m', 'RED':'\033[91m', 'YELLOW':'\033[93m', 'RESET':'\033[0m'}
TEXT_DECORATION={'BLINK':'\033[5m', 'BOLD':'\033[1m','RESET':'\033[0m'}
LOCAL_CONFIG_DIR = "/opt/cyops/configs/fsr-elevate/local_download"
LOCAL_PACKAGES_CONFIG_FILE = f"{LOCAL_CONFIG_DIR}/local_download.conf"
LOCAL_YUM_CONFIG_FILE = f"{LOCAL_CONFIG_DIR}/local_yum.conf"
LOCAL_PACKAGES_DOWNLOAD_DIR = "/opt/cyops/packages"
LOCAL_PACKAGES_DIR = "fsr-packages"
LOCAL_SYSTEM_CONNECTORS_DIR = "fsr-connectors"
CONNECTORS_LIST = ["cyops-connector-cyops_utilities", "cyops-connector-imap", "cyops-connector-smtp", "cyops-connector-cyops-schedule-report", "cyops-connector-code-snippet",
                              "cyops-connector-cyops-system-monitoring", "cyops-connector-fortisoar-ml-engine", "cyops-connector-fsr-agent-communication-bridge", "cyops-connector-phishing-classifier"]
UPGRADE_SUPPORT_VERSION_FILE = "upgrade_support_versions.json"
UPGRADE_PATH_FILE = "upgrade_path.json"
FSR_ELEVATE_USER = "root"                               
TASK_STATUS = {"DONE":"DONE", "FAILED":"FAILED"}
TASK_LOG_STATUS = {"STARTED":"STARTED","COMPLETED":"COMPLETED"}
TEXT_COLOR = {'GREEN':'\033[92m', 'RED':'\033[91m', 'YELLOW':'\033[93m', 'RESET':'\033[0m'}
TEXT_DECORATION = {'BLINK':'\033[5m', 'BOLD':'\033[1m','RESET':'\033[0m'}